Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Crossovers/GQAPPathRelinking.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Crossovers/GQAPPathRelinking.cs	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Crossovers/GQAPPathRelinking.cs	(revision 7970)
@@ -37,5 +37,5 @@
   public class GQAPPathRelinking : GQAPCrossover, IQualitiesAwareGQAPOperator, IDemandsAwareGQAPOperator, ICapacitiesAwareGQAPOperator,
   IWeightsAwareGQAPOperator, IDistancesAwareGQAPOperator, IInstallationCostsAwareGQAPOperator, ITransportationCostsAwareGQAPOperator,
-  IOverbookedCapacityPenaltyAwareGQAPOperator {
+  IExpectedRandomQualityAwareGQAPOperator, IEvaluatorAwareGQAPOperator {
 
     public ILookupParameter<BoolValue> MaximizationParameter {
@@ -72,6 +72,9 @@
       get { return (IValueLookupParameter<DoubleValue>)Parameters["TransportationCosts"]; }
     }
-    public IValueLookupParameter<DoubleValue> OverbookedCapacityPenaltyParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["OverbookedCapacityPenalty"]; }
+    public IValueLookupParameter<DoubleValue> ExpectedRandomQualityParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["ExpectedRandomQuality"]; }
+    }
+    public IValueLookupParameter<IGQAPEvaluator> EvaluatorParameter {
+      get { return (IValueLookupParameter<IGQAPEvaluator>)Parameters["Evaluator"]; }
     }
 
@@ -96,5 +99,6 @@
       Parameters.Add(new LookupParameter<DoubleMatrix>("InstallationCosts", GeneralizedQuadraticAssignmentProblem.InstallationCostsDescription));
       Parameters.Add(new ValueLookupParameter<DoubleValue>("TransportationCosts", GeneralizedQuadraticAssignmentProblem.TransportationCostsDescription));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("OverbookedCapacityPenalty", GeneralizedQuadraticAssignmentProblem.OverbookedCapacityPenaltyDescription));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("ExpectedRandomQuality", GeneralizedQuadraticAssignmentProblem.ExpectedRandomQualityDescription));
+      Parameters.Add(new ValueLookupParameter<IGQAPEvaluator>("Evaluator", "The evaluator that is used to evaluate GQAP solutions."));
       Parameters.Add(new ValueParameter<PercentValue>("CandidateSizeFactor", "(η) Determines the size of the set of feasible moves in each path-relinking step relative to the maximum size. A value of 50% means that only half of all possible moves are considered each step.", new PercentValue(0.5)));
     }
@@ -107,5 +111,5 @@
       ItemArray<DoubleValue> flowDistanceQualities, ItemArray<DoubleValue> installationQualities, ItemArray<DoubleValue> overbookedCapacities,
       DoubleArray demands, DoubleArray capacities, DoubleMatrix weights, DoubleMatrix distances, DoubleMatrix installationCosts,
-      DoubleValue transportationCosts, DoubleValue overbookedCapacityPenalty, DoubleValue candidateSizeFactor) {
+      DoubleValue transportationCosts, DoubleValue expectedRandomQuality, DoubleValue candidateSizeFactor, IGQAPEvaluator evaluator) {
       if (random == null) throw new ArgumentNullException("random", "No IRandom provider is given.");
       if (parents == null || !parents.Any()) throw new ArgumentException("No parents given for path relinking.", "parents");
@@ -145,10 +149,10 @@
 
           double currentFDQ, currentIQ, currentOC;
-          GQAPEvaluator.Evaluate(pi2, weights, distances, installationCosts, demands, capacities,
+          evaluator.Evaluate(pi2, weights, distances, installationCosts, demands, capacities,
             out currentFDQ, out currentIQ, out currentOC);
 
           if (currentOC <= 0.0) {
-            var quality = GQAPEvaluator.GetCombinedQuality(currentFDQ, currentIQ, currentOC,
-                transportationCosts.Value, overbookedCapacityPenalty.Value);
+            var quality = evaluator.GetFitness(currentFDQ, currentIQ, currentOC,
+              transportationCosts.Value, expectedRandomQuality.Value);
             var solution = new GQAPSolution(pi2, new DoubleValue(quality), new DoubleValue(currentFDQ),
               new DoubleValue(currentIQ), new DoubleValue(currentOC));
@@ -211,5 +215,6 @@
         CapacitiesParameter.ActualValue, WeightsParameter.ActualValue, DistancesParameter.ActualValue,
         InstallationCostsParameter.ActualValue, TransportationCostsParameter.ActualValue,
-        OverbookedCapacityPenaltyParameter.ActualValue, CandidateSizeFactorParameter.Value);
+        ExpectedRandomQualityParameter.ActualValue, CandidateSizeFactorParameter.Value,
+        EvaluatorParameter.ActualValue);
     }
 
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/LocalImprovers/ApproximateLocalSearch.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/LocalImprovers/ApproximateLocalSearch.cs	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/LocalImprovers/ApproximateLocalSearch.cs	(revision 7970)
@@ -37,6 +37,7 @@
   public class ApproximateLocalSearch : SingleSuccessorOperator, IDemandsAwareGQAPOperator, ICapacitiesAwareGQAPOperator,
     IWeightsAwareGQAPOperator, IDistancesAwareGQAPOperator, IInstallationCostsAwareGQAPOperator,
-    ITransportationCostsAwareGQAPOperator, IOverbookedCapacityPenaltyAwareGQAPOperator,
-    IAssignmentAwareGQAPOperator, IQualityAwareGQAPOperator, IGQAPLocalImprovementOperator, IStochasticOperator {
+    ITransportationCostsAwareGQAPOperator, IExpectedRandomQualityAwareGQAPOperator,
+    IAssignmentAwareGQAPOperator, IQualityAwareGQAPOperator, IGQAPLocalImprovementOperator,
+    IEvaluatorAwareGQAPOperator, IStochasticOperator {
     public IProblem Problem { get; set; }
     public Type ProblemType {
@@ -62,6 +63,6 @@
       get { return (IValueLookupParameter<DoubleValue>)Parameters["TransportationCosts"]; }
     }
-    public IValueLookupParameter<DoubleValue> OverbookedCapacityPenaltyParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["OverbookedCapacityPenalty"]; }
+    public IValueLookupParameter<DoubleValue> ExpectedRandomQualityParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["ExpectedRandomQuality"]; }
     }
     public ILookupParameter<IntegerVector> AssignmentParameter {
@@ -100,4 +101,7 @@
     public ILookupParameter<ResultCollection> ResultsParameter {
       get { return (ILookupParameter<ResultCollection>)Parameters["Results"]; }
+    }
+    public IValueLookupParameter<IGQAPEvaluator> EvaluatorParameter {
+      get { return (IValueLookupParameter<IGQAPEvaluator>)Parameters["Evaluator"]; }
     }
 
@@ -113,5 +117,5 @@
       Parameters.Add(new LookupParameter<DoubleMatrix>("InstallationCosts", GeneralizedQuadraticAssignmentProblem.InstallationCostsDescription));
       Parameters.Add(new ValueLookupParameter<DoubleValue>("TransportationCosts", GeneralizedQuadraticAssignmentProblem.TransportationCostsDescription));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("OverbookedCapacityPenalty", GeneralizedQuadraticAssignmentProblem.OverbookedCapacityPenaltyDescription));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("ExpectedRandomQuality", GeneralizedQuadraticAssignmentProblem.ExpectedRandomQualityDescription));
       Parameters.Add(new LookupParameter<IntegerVector>("Assignment", GQAPSolutionCreator.AssignmentDescription));
       Parameters.Add(new LookupParameter<BoolValue>("Maximization", GeneralizedQuadraticAssignmentProblem.MaximizationDescription));
@@ -126,4 +130,5 @@
       Parameters.Add(new ValueLookupParameter<PercentValue>("OneMoveProbability", "The probability for performing a 1-move, which is the opposite of performing a 2-move.", new PercentValue(.5)));
       Parameters.Add(new LookupParameter<ResultCollection>("Results", "The result collection that stores the results."));
+      Parameters.Add(new ValueLookupParameter<IGQAPEvaluator>("Evaluator", "The evaluator that is used to evaluate GQAP solutions."));
     }
 
@@ -157,5 +162,6 @@
       IntValue maxCLS, IntValue maximumIterations,
       DoubleMatrix weights, DoubleMatrix distances, DoubleMatrix installationCosts, DoubleArray demands, DoubleArray capacities,
-      DoubleValue transportationCosts, DoubleValue overbookedCapacityPenalty, PercentValue oneMoveProbability) {
+      DoubleValue transportationCosts, DoubleValue expectedRandomQuality, PercentValue oneMoveProbability,
+      IGQAPEvaluator evaluator) {
 
       while (true) {
@@ -171,7 +177,7 @@
           double moveFlowDistanceQuality, moveInstallationQuality, moveOverbookedCapacity;
           GQAPNMoveEvaluator.Evaluate(move, assignment, weights, distances, installationCosts,
-            demands, capacities, out moveFlowDistanceQuality, out moveInstallationQuality, out moveOverbookedCapacity);
-          double moveQuality = GQAPEvaluator.GetCombinedQuality(moveFlowDistanceQuality, moveInstallationQuality, moveOverbookedCapacity,
-            transportationCosts.Value, overbookedCapacityPenalty.Value);
+            demands, capacities, evaluator, out moveFlowDistanceQuality, out moveInstallationQuality, out moveOverbookedCapacity);
+          double moveQuality = evaluator.GetFitness(moveFlowDistanceQuality, moveInstallationQuality, moveOverbookedCapacity,
+            transportationCosts.Value, expectedRandomQuality.Value);
 
           if (moveOverbookedCapacity <= 0.0 && moveQuality < 0.0) {
@@ -216,6 +222,7 @@
         DemandsParameter.ActualValue, CapacitiesParameter.ActualValue,
         TransportationCostsParameter.ActualValue,
-        OverbookedCapacityPenaltyParameter.ActualValue,
-        OneMoveProbabilityParameter.ActualValue);
+        ExpectedRandomQualityParameter.ActualValue,
+        OneMoveProbabilityParameter.ActualValue,
+        EvaluatorParameter.ActualValue);
       return base.Apply();
     }
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/SolutionCreators/GreedyRandomizedSolutionCreator.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/SolutionCreators/GreedyRandomizedSolutionCreator.cs	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/SolutionCreators/GreedyRandomizedSolutionCreator.cs	(revision 7970)
@@ -35,5 +35,6 @@
   [Item("GreedyRandomizedSolutionCreator", "Creates a solution according to the procedure described in Mateus, G., Resende, M., and Silva, R. 2011. GRASP with path-relinking for the generalized quadratic assignment problem. Journal of Heuristics 17, Springer Netherlands, pp. 527-565.")]
   [StorableClass]
-  public class GreedyRandomizedSolutionCreator : GQAPStochasticSolutionCreator {
+  public class GreedyRandomizedSolutionCreator : GQAPStochasticSolutionCreator,
+    IEvaluatorAwareGQAPOperator {
 
     public IValueLookupParameter<IntValue> MaximumTriesParameter {
@@ -42,4 +43,7 @@
     public IValueLookupParameter<BoolValue> CreateMostFeasibleSolutionParameter {
       get { return (IValueLookupParameter<BoolValue>)Parameters["CreateMostFeasibleSolution"]; }
+    }
+    public IValueLookupParameter<IGQAPEvaluator> EvaluatorParameter {
+      get { return (IValueLookupParameter<IGQAPEvaluator>)Parameters["Evaluator"]; }
     }
 
@@ -52,4 +56,5 @@
       Parameters.Add(new ValueLookupParameter<IntValue>("MaximumTries", "The maximum number of tries to create a feasible solution after which an exception is thrown. If it is set to 0 or a negative value there will be an infinite number of attempts.", new IntValue(100000)));
       Parameters.Add(new ValueLookupParameter<BoolValue>("CreateMostFeasibleSolution", "If this is set to true the operator will always succeed, and outputs the solution with the least violation instead of throwing an exception.", new BoolValue(false)));
+      Parameters.Add(new ValueLookupParameter<IGQAPEvaluator>("Evaluator", "The evaluator that is used to evaluate GQAP solutions."));
     }
 
@@ -58,5 +63,7 @@
     }
 
-    public static IntegerVector CreateSolution(IRandom random, DoubleArray demands, DoubleArray capacities, int maximumTries, bool createMostFeasibleSolution, CancellationToken cancelToken) {
+    public static IntegerVector CreateSolution(IRandom random, DoubleArray demands, DoubleArray capacities,
+      IGQAPEvaluator evaluator,
+      int maximumTries, bool createMostFeasibleSolution, CancellationToken cancelToken) {
       int tries = 0;
       var assignment = new Dictionary<int, int>(demands.Length);
@@ -118,5 +125,5 @@
             slack[l] -= demands[f];
           }
-          double violation = GQAPEvaluator.EvaluateOverbooking(slack, capacities);
+          double violation = evaluator.EvaluateOverbooking(slack, capacities);
           if (violation < minViolation) {
             bestAssignment = assignment;
@@ -134,4 +141,5 @@
     protected override IntegerVector CreateRandomSolution(IRandom random, DoubleArray demands, DoubleArray capacities) {
       return CreateSolution(random, demands, capacities,
+        EvaluatorParameter.ActualValue,
         MaximumTriesParameter.ActualValue.Value,
         CreateMostFeasibleSolutionParameter.ActualValue.Value,
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/SolutionCreators/RandomButFeasibleSolutionCreator.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/SolutionCreators/RandomButFeasibleSolutionCreator.cs	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/SolutionCreators/RandomButFeasibleSolutionCreator.cs	(revision 7970)
@@ -35,5 +35,6 @@
   [Item("RandomButFeasibleSolutionCreator", "Creates a random, but feasible solution to the Generalized Quadratic Assignment Problem.")]
   [StorableClass]
-  public class RandomFeasibleSolutionCreator : GQAPStochasticSolutionCreator {
+  public class RandomFeasibleSolutionCreator : GQAPStochasticSolutionCreator,
+    IEvaluatorAwareGQAPOperator {
 
     public IValueLookupParameter<IntValue> MaximumTriesParameter {
@@ -42,4 +43,7 @@
     public IValueLookupParameter<BoolValue> CreateMostFeasibleSolutionParameter {
       get { return (IValueLookupParameter<BoolValue>)Parameters["CreateMostFeasibleSolution"]; }
+    }
+    public IValueLookupParameter<IGQAPEvaluator> EvaluatorParameter {
+      get { return (IValueLookupParameter<IGQAPEvaluator>)Parameters["Evaluator"]; }
     }
 
@@ -51,4 +55,5 @@
       Parameters.Add(new ValueLookupParameter<IntValue>("MaximumTries", "The maximum number of tries to create a feasible solution after which an exception is thrown. If it is set to 0 or a negative value there will be an infinite number of attempts.", new IntValue(100000)));
       Parameters.Add(new ValueLookupParameter<BoolValue>("CreateMostFeasibleSolution", "If this is set to true the operator will always succeed, and outputs the solution with the least violation instead of throwing an exception.", new BoolValue(false)));
+      Parameters.Add(new ValueLookupParameter<IGQAPEvaluator>("Evaluator", "The evaluator that is used to evaluate GQAP solutions."));
     }
 
@@ -57,5 +62,7 @@
     }
 
-    public static IntegerVector CreateSolution(IRandom random, DoubleArray demands, DoubleArray capacities, int maximumTries, bool createMostFeasibleSolution, CancellationToken cancel) {
+    public static IntegerVector CreateSolution(IRandom random, DoubleArray demands,
+      DoubleArray capacities, IGQAPEvaluator evaluator,
+      int maximumTries, bool createMostFeasibleSolution, CancellationToken cancel) {
       IntegerVector result = null;
       bool isFeasible = false;
@@ -80,5 +87,5 @@
           slack[assignment[equipment]] -= demands[equipment];
         }
-        double violation = GQAPEvaluator.EvaluateOverbooking(slack, capacities);
+        double violation = evaluator.EvaluateOverbooking(slack, capacities);
         isFeasible = violation == 0;
         if (isFeasible || violation < minViolation) {
@@ -92,4 +99,5 @@
     protected override IntegerVector CreateRandomSolution(IRandom random, DoubleArray demands, DoubleArray capacities) {
       return CreateSolution(random, demands, capacities,
+        EvaluatorParameter.ActualValue,
         MaximumTriesParameter.ActualValue.Value,
         CreateMostFeasibleSolutionParameter.ActualValue.Value,
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/SolutionCreators/SlackMinimizationSolutionCreator.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/SolutionCreators/SlackMinimizationSolutionCreator.cs	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/SolutionCreators/SlackMinimizationSolutionCreator.cs	(revision 7970)
@@ -35,5 +35,6 @@
   [Item("SlackMinimizationSolutionCreator", "A heuristic that creates a solution to the Generalized Quadratic Assignment Problem by minimizing the amount of slack.")]
   [StorableClass]
-  public class SlackMinimizationSolutionCreator : GQAPStochasticSolutionCreator {
+  public class SlackMinimizationSolutionCreator : GQAPStochasticSolutionCreator,
+    IEvaluatorAwareGQAPOperator {
 
     public IValueLookupParameter<IntValue> MaximumTriesParameter {
@@ -49,4 +50,7 @@
       get { return (IValueLookupParameter<IntValue>)Parameters["RandomWalkLength"]; }
     }
+    public IValueLookupParameter<IGQAPEvaluator> EvaluatorParameter {
+      get { return (IValueLookupParameter<IGQAPEvaluator>)Parameters["Evaluator"]; }
+    }
 
     [StorableConstructor]
@@ -59,4 +63,5 @@
       Parameters.Add(new ValueLookupParameter<IntValue>("Depth", "How deep the algorithm should look forward.", new IntValue(3)));
       Parameters.Add(new ValueLookupParameter<IntValue>("RandomWalkLength", "The length of the random walk in the feasible region that is used to diversify the found assignments.", new IntValue(10)));
+      Parameters.Add(new ValueLookupParameter<IGQAPEvaluator>("Evaluator", "The evaluator that is used to evaluate GQAP solutions."));
     }
 
@@ -75,5 +80,7 @@
     }
 
-    public static IntegerVector CreateSolution(IRandom random, DoubleArray demands, DoubleArray capacities, int depth, int maximumTries, bool createMostFeasibleSolution, int randomWalkLength, CancellationToken cancel) {
+    public static IntegerVector CreateSolution(IRandom random, DoubleArray demands,
+      DoubleArray capacities, IGQAPEvaluator evaluator,
+      int depth, int maximumTries, bool createMostFeasibleSolution, int randomWalkLength, CancellationToken cancel) {
       IntegerVector result = null;
       bool isFeasible = false;
@@ -118,5 +125,5 @@
           }
         } else RandomFeasibleWalk(random, assignment, demands, slack, randomWalkLength);
-        double violation = GQAPEvaluator.EvaluateOverbooking(slack, capacities);
+        double violation = evaluator.EvaluateOverbooking(slack, capacities);
         isFeasible = violation == 0;
         if (isFeasible || violation < minViolation) {
@@ -177,4 +184,5 @@
     protected override IntegerVector CreateRandomSolution(IRandom random, DoubleArray demands, DoubleArray capacities) {
       return CreateSolution(random, demands, capacities,
+        EvaluatorParameter.ActualValue,
         DepthParameter.ActualValue.Value,
         MaximumTriesParameter.ActualValue.Value,
Index: branches/GeneralizedQAP/UnitTests/CordeauCrossoverTest.cs
===================================================================
--- branches/GeneralizedQAP/UnitTests/CordeauCrossoverTest.cs	(revision 7968)
+++ branches/GeneralizedQAP/UnitTests/CordeauCrossoverTest.cs	(revision 7970)
@@ -46,8 +46,8 @@
           CordeauCrossover.Apply(random, gqap.Maximization,
             parent1,
-            new DoubleValue(GQAPEvaluator.Evaluate(parent1, gqap.Weights, gqap.Distances, gqap.InstallationCosts, gqap.Demands, gqap.Capacities, gqap.TransportationCosts, gqap.OverbookedCapacityPenalty)),
+            new DoubleValue(gqap.Evaluator.Evaluate(parent1, gqap.Weights, gqap.Distances, gqap.InstallationCosts, gqap.Demands, gqap.Capacities, gqap.TransportationCosts, gqap.ExpectedRandomQuality)),
             parent2,
-            new DoubleValue(GQAPEvaluator.Evaluate(parent2, gqap.Weights, gqap.Distances, gqap.InstallationCosts, gqap.Demands, gqap.Capacities, gqap.TransportationCosts, gqap.OverbookedCapacityPenalty)),
-            gqap.Weights, gqap.Distances, gqap.InstallationCosts, gqap.Demands, gqap.Capacities, gqap.TransportationCosts, gqap.OverbookedCapacityPenalty);
+            new DoubleValue(gqap.Evaluator.Evaluate(parent2, gqap.Weights, gqap.Distances, gqap.InstallationCosts, gqap.Demands, gqap.Capacities, gqap.TransportationCosts, gqap.ExpectedRandomQuality)),
+            gqap.Weights, gqap.Distances, gqap.InstallationCosts, gqap.Demands, gqap.Capacities, gqap.TransportationCosts, gqap.ExpectedRandomQuality, gqap.Evaluator);
         } catch {
           Assert.Fail("Error during crossover");
Index: branches/GeneralizedQAP/UnitTests/GQAPNMoveEvaluatorTest.cs
===================================================================
--- branches/GeneralizedQAP/UnitTests/GQAPNMoveEvaluatorTest.cs	(revision 7968)
+++ branches/GeneralizedQAP/UnitTests/GQAPNMoveEvaluatorTest.cs	(revision 7970)
@@ -39,5 +39,5 @@
     private static DoubleMatrix installationCosts;
     private static DoubleArray demands, capacities;
-    private static DoubleValue transportationCosts, overbookedCapacityPenalty;
+    private static double transportationCosts, overbookedCapacityPenalty;
     private static IntegerVector assignment;
     private static MersenneTwister random;
@@ -107,6 +107,6 @@
         nonZeroDiagonalWeights[index, index] = random.Next(1, Equipments * 100);
 
-      transportationCosts = new DoubleValue(random.NextDouble() * 10);
-      overbookedCapacityPenalty = new DoubleValue(1000 * random.NextDouble() + 100);
+      transportationCosts = random.NextDouble() * 10;
+      overbookedCapacityPenalty = 1000 * random.NextDouble() + 100;
       assignment = new IntegerVector(Equipments, random, 0, Locations);
     }
@@ -119,23 +119,24 @@
     [TestMethod()]
     public void EvaluateTest() {
+      var evaluator = new GQAPAdditivePenaltyEvaluator();
       for (int i = 0; i < 500; i++) {
         NMove currentMove = StochasticNMoveSingleMoveGenerator.GenerateUpToN(random, assignment, 3, capacities);
         IntegerVector prevAssignment = (IntegerVector)assignment.Clone();
         NMoveMaker.Apply(assignment, currentMove);
-        double before = GQAPEvaluator.Evaluate(prevAssignment, symmetricWeights, symmetricDistances, installationCosts, demands, capacities, transportationCosts, overbookedCapacityPenalty);
-        double after = GQAPEvaluator.Evaluate(assignment, symmetricWeights, symmetricDistances, installationCosts, demands, capacities, transportationCosts, overbookedCapacityPenalty);
-        double moveDiff = GQAPNMoveEvaluator.Evaluate(currentMove, prevAssignment, symmetricWeights, symmetricDistances, installationCosts, demands, capacities, transportationCosts, overbookedCapacityPenalty);
+        double before = evaluator.Evaluate(prevAssignment, symmetricWeights, symmetricDistances, installationCosts, demands, capacities, transportationCosts, 0);
+        double after = evaluator.Evaluate(assignment, symmetricWeights, symmetricDistances, installationCosts, demands, capacities, transportationCosts, 0);
+        double moveDiff = GQAPNMoveEvaluator.Evaluate(currentMove, prevAssignment, symmetricWeights, symmetricDistances, installationCosts, demands, capacities, transportationCosts, 0, evaluator);
         Assert.IsTrue(Math.Abs(moveDiff - (after - before)) < 1e-07, "Failed on symmetric matrices: " + Environment.NewLine
           + "Quality changed from " + before + " to " + after + " (" + (after - before).ToString() + "), but move quality change was " + moveDiff + ".");
 
-        before = GQAPEvaluator.Evaluate(prevAssignment, asymmetricWeights, asymmetricDistances, installationCosts, demands, capacities, transportationCosts, overbookedCapacityPenalty);
-        after = GQAPEvaluator.Evaluate(assignment, asymmetricWeights, asymmetricDistances, installationCosts, demands, capacities, transportationCosts, overbookedCapacityPenalty);
-        moveDiff = GQAPNMoveEvaluator.Evaluate(currentMove, prevAssignment, asymmetricWeights, asymmetricDistances, installationCosts, demands, capacities, transportationCosts, overbookedCapacityPenalty);
+        before = evaluator.Evaluate(prevAssignment, asymmetricWeights, asymmetricDistances, installationCosts, demands, capacities, transportationCosts, 0);
+        after = evaluator.Evaluate(assignment, asymmetricWeights, asymmetricDistances, installationCosts, demands, capacities, transportationCosts, 0);
+        moveDiff = GQAPNMoveEvaluator.Evaluate(currentMove, prevAssignment, asymmetricWeights, asymmetricDistances, installationCosts, demands, capacities, transportationCosts, 0, evaluator);
         Assert.IsTrue(Math.Abs(moveDiff - (after - before)) < 1e-07, "Failed on asymmetric matrices: " + Environment.NewLine
           + "Quality changed from " + before + " to " + after + " (" + (after - before).ToString() + "), but move quality change was " + moveDiff + ".");
 
-        before = GQAPEvaluator.Evaluate(prevAssignment, nonZeroDiagonalWeights, nonZeroDiagonalDistances, installationCosts, demands, capacities, transportationCosts, overbookedCapacityPenalty);
-        after = GQAPEvaluator.Evaluate(assignment, nonZeroDiagonalWeights, nonZeroDiagonalDistances, installationCosts, demands, capacities, transportationCosts, overbookedCapacityPenalty);
-        moveDiff = GQAPNMoveEvaluator.Evaluate(currentMove, prevAssignment, nonZeroDiagonalWeights, nonZeroDiagonalDistances, installationCosts, demands, capacities, transportationCosts, overbookedCapacityPenalty);
+        before = evaluator.Evaluate(prevAssignment, nonZeroDiagonalWeights, nonZeroDiagonalDistances, installationCosts, demands, capacities, transportationCosts, 0);
+        after = evaluator.Evaluate(assignment, nonZeroDiagonalWeights, nonZeroDiagonalDistances, installationCosts, demands, capacities, transportationCosts, 0);
+        moveDiff = GQAPNMoveEvaluator.Evaluate(currentMove, prevAssignment, nonZeroDiagonalWeights, nonZeroDiagonalDistances, installationCosts, demands, capacities, transportationCosts, 0, evaluator);
         Assert.IsTrue(Math.Abs(moveDiff - (after - before)) < 1e-07, "Failed on non-zero diagonal matrices: " + Environment.NewLine
           + "Quality changed from " + before + " to " + after + " (" + (after - before).ToString() + "), but move quality change was " + moveDiff + ".");
Index: branches/GeneralizedQAP/UnitTests/UnitTests.csproj
===================================================================
--- branches/GeneralizedQAP/UnitTests/UnitTests.csproj	(revision 7968)
+++ branches/GeneralizedQAP/UnitTests/UnitTests.csproj	(revision 7970)
@@ -81,10 +81,10 @@
       <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Problems.Instances-3.3.dll</HintPath>
       <SpecificVersion>False</SpecificVersion>
-      <Private>False</Private>
+      <Private>True</Private>
     </Reference>
     <Reference Include="HeuristicLab.Problems.Instances.CordeauGQAP-3.3">
       <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Problems.Instances.CordeauGQAP-3.3.dll</HintPath>
       <SpecificVersion>False</SpecificVersion>
-      <Private>False</Private>
+      <Private>True</Private>
     </Reference>
     <Reference Include="HeuristicLab.Random-3.3">
